%  Phi1.m
function [DhatInv] = Phi1(Dinv,d,k,J,n)
%  Computes DhatInv from Dinv, d, k using Procdure Phi1.
%  Suppresses update of conjugate direction columns.
check = d' * Dinv(:,k);
if abs(check) < 1.e-6
    errmsg = 'new matrix is singular'
    soln = 'Press Ctrl+C to continue'
    pause
    return
end
check = 1. / check;
DhatInv(:,k) = Dinv(:,k) * check;
for i = 1:n
    if  i~=k
        if J(i) ~= -1
            dci = d' * Dinv(:,i);
            DhatInv(:,i) = Dinv(:,i) - dci*DhatInv(:,k);
        end
        if J(i) == -1;
            DhatInv(:,i) = Dinv(:,i);
        end
    end
end
end