%  Phi2.m
function[DhatInv] = Phi2(Dinv,d,nu,J,n)
%  Procedure Phi2:  Replaces an existing set of columns which
%  are conjugate direcions with a second set for which all
%  are orthogonal to a given vector d.
y = zeros(n,1);
for i=1:n
    if J(i) == -1
        y(i) = d' * Dinv(:,i);
    end
end
enu = zeros(n,1);
enu(nu) = 1;
t1 = norm(y) * enu;
t2 = norm(t1 - y);
if t2 <= 1.e-6
    mu = -1;
else
    mu = 1;
end
t3 = (mu*norm(y)*enu - y);
t4 = norm(mu*norm(y)*enu - y);
t4 = 1./t4;
for i = 1:n
    t3(i) = t4*t3(i);
end
t3;
w = t3;
%  Dinv(:,j) = column j of Dinv
p = zeros(n,1);
for i=1:n
    if J(i) == -1
        p = p + w(i)*Dinv(:,i);
    end
end
for i=1:n
    if J(i) == -1
        DhatInv(:,i) = Dinv(:,i) - 2*w(i)*p;
    end
end

for i=1:n
    if J(i) ~= -1
        DhatInv(:,i) = Dinv(:,i);
    end
end

    
    
    
    
    



























